<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2013  BSI

    Version history:
      1.0.0  01-Aug-11  First release
      1.0.1  22-Aug-11
      1.0.2   3-Nov-11  Fixed problem with creating content items which cannot be reordered
      1.0.4  29-Jan-13  Updated receipt options for Leanr 9.1 SP10
                        Added docType and contentType
      1.0.6  16-Jun-13
      1.0.7  18-Jun-13
      1.0.8  27-Jun-13
      1.0.9  14-Jul-13  Changed content to render type REGULAR
                        Update line item to match content title
      1.1.0  17-Feb-14
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@page contentType="text/html" pageEncoding="UTF-8"
        import="java.util.Map,
                java.util.HashMap,
                java.net.URLEncoder,
                java.io.UnsupportedEncodingException,
                blackboard.platform.log.LogService.Verbosity,
                blackboard.platform.BbServiceManager,
                blackboard.platform.persistence.PersistenceServiceFactory,
                blackboard.platform.config.BbConfig,
                blackboard.persist.BbPersistenceManager,
                blackboard.data.content.Content,
                blackboard.persist.content.ContentDbLoader,
                blackboard.data.course.Course,
                blackboard.data.gradebook.Lineitem,
                blackboard.persist.*,
                blackboard.platform.persistence.*,
                blackboard.base.FormattedText,
                blackboard.base.FormattedText.*,
                blackboard.servlet.data.WysiwygText,
                blackboard.persist.content.ContentDbPersister,
                blackboard.servlet.tags.ngui.datacollection.fields.TextboxTag,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.biosig_id.blackboard.Constants,
                com.biosig_id.blackboard.Utils,
                com.biosig_id.blackboard.Gradebook"
        errorPage="../error.jsp" %>
<%@taglib uri="/bbNG" prefix="bbNG" %>
<%@ taglib prefix="bbng" uri="/bbNG" %>
<bbNG:learningSystemPage title="${bundle['page.content.title']}">
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering instance.jsp");
  pageContext.setAttribute("bundle", b2Context.getResourceStrings());
  String courseId = b2Context.getRequestParameter(Constants.COURSE_ID_PARAM_NAME, "");
  String contentId = b2Context.getRequestParameter(Constants.CONTENT_ID_PARAM_NAME, "");
  String cancelUrl = b2Context.getNavigationItem("cp_content_quickedit").getHref();
  cancelUrl = cancelUrl.replace("@X@course.pk_string@X@", courseId);
  cancelUrl = cancelUrl.replace("@X@content.pk_string@X@", contentId);

  String mode = b2Context.getRequestParameter(Constants.MODE_PARAMETER, Constants.MODE_NEW);
  String name = b2Context.getRequestParameter(Constants.TITLE_PARAMETER, "");
  name = name.trim();
  String allowUnlim = b2Context.getRequestParameter(Constants.ALLOW_UNLIMITED, "");
  allowUnlim = allowUnlim.trim();

  Map<String,String> params = new HashMap<String,String>();

  BbPersistenceManager bbPm = PersistenceServiceFactory.getInstance().getDbPersistenceManager();
  ContentDbLoader courseDocumentLoader = (ContentDbLoader)bbPm.getLoader(ContentDbLoader.TYPE);
  Content content = null;
  if (!mode.equals(Constants.MODE_NEW)) {
    Id id = bbPm.generateId(Content.DATA_TYPE, contentId);
    content = courseDocumentLoader.loadById(id);
  }

  ContentDbPersister persister = (ContentDbPersister)bbPm.getPersister(ContentDbPersister.TYPE);

  if (request.getMethod().equalsIgnoreCase("POST") && (name.length() > 0)) {

//    String contentUrl = b2Context.getPath() + "ch/view.jsp?" +
//       Constants.COURSE_ID_PARAM_NAME + "=" + courseId + "&" +
//       Constants.CONTENT_ID_PARAM_NAME + "=";
    if (!mode.equals(Constants.MODE_MODIFY)) {
      content = new Content();
      content.setContentHandler(Constants.RESOURCE_HANDLE);
      Id childId = bbPm.generateId(Course.DATA_TYPE, courseId);
      Id parentId = bbPm.generateId(Content.DATA_TYPE, contentId);
      content.setCourseId(childId);
      content.setParentId(parentId);
      content.setRenderType(Content.RenderType.DEFAULT);
      content.setTitle(name);
      persister.persist(content);

      b2Context.setContent(content);
      b2Context.setSaveEmptyValues(false);
      b2Context.setSetting(false, true, Constants.ALLOW_UNLIMITED, allowUnlim);
      b2Context.persistSettings(false, true);
// Reload content item to set URL
      content = courseDocumentLoader.loadById(content.getId());
    } else {
      content.setTitle(name);

      b2Context.setSaveEmptyValues(false);
      b2Context.setSetting(false, true, Constants.ALLOW_UNLIMITED, allowUnlim);
      b2Context.persistSettings(false, true);

      persister.persist(content);
    }
//    content.setUrl(contentUrl + contentId);
    String paramName = Constants.DESCRIPTION_PARAMETER;
    if (!blackboard.platform.config.ConfigurationServiceFactory.getInstance().getBbProperty(BbConfig.VERSION_NUMBER, "").startsWith("9.0.")) {
      paramName += "_";
    }
    FormattedText text = TextboxTag.getFormattedText(request, paramName);
    content.setBody(text);
    contentId = content.getId().toExternalString();
//    content.setUrl(contentUrl + contentId);
    persister.persist(content);

    Lineitem col = Gradebook.getColumn(courseId, contentId, true);
    if (col != null) {
      Utils.checkLineItemTitle(content.getId(), col);
    }

    String receiptMessage = null;
    if (!mode.equals(Constants.MODE_MODIFY)) {
      receiptMessage = b2Context.getResourceString("page.content.receipt.add.success");
    } else {
      receiptMessage = b2Context.getResourceString("page.content.receipt.modify.success");
    }
    cancelUrl = b2Context.setReceiptOptions(cancelUrl, receiptMessage, null);
    response.sendRedirect(cancelUrl);
    Utils.log(Verbosity.INFORMATION, "Exiting instance.jsp");
    return;

  } else {

    params.put("descriptionname", Constants.DESCRIPTION_PARAMETER + "_");
    if (mode.equals(Constants.MODE_MODIFY) && !request.getMethod().equalsIgnoreCase("POST")) {
      params.put("title", content.getTitle());
      params.put("descriptiontype", content.getBody().getType().toFieldName().substring(0, 1));
      params.put("descriptiontext", content.getBody().getText());
      params.put("allowunlimited", b2Context.getSetting(false, true, Constants.ALLOW_UNLIMITED, Constants.DATA_FALSE));
    } else if (request.getMethod().equalsIgnoreCase("POST")) {
      params.put(Constants.TITLE_PARAMETER, b2Context.getRequestParameter(Constants.TITLE_PARAMETER, ""));
      params.put("descriptiontype", b2Context.getRequestParameter(Constants.DESCRIPTION_PARAMETER + "_type", "H"));
      params.put("descriptiontext", b2Context.getRequestParameter(Constants.DESCRIPTION_PARAMETER + "_text", ""));
      params.put("allowunlimited", b2Context.getSetting(false, true, Constants.ALLOW_UNLIMITED, Constants.DATA_FALSE));
    } else {
      params.put("title", b2Context.getSetting(Constants.TITLE_PARAMETER, ""));
      params.put("descriptiontype", b2Context.getSetting(Constants.DESCRIPTION_TYPE_PARAMETER, "H"));
      params.put("descriptiontext", b2Context.getSetting(Constants.DESCRIPTION_PARAMETER, ""));
      params.put("allowunlimited", Constants.DATA_FALSE);
    }

    pageContext.setAttribute("params", params);

    if (mode.equals(Constants.MODE_MODIFY)) {
      if (!content.getRenderType().equals(Content.RenderType.REGULAR)) {
        content.setRenderType(Content.RenderType.REGULAR);
        content.setUrl(null);
        persister.persist(content);
      }
      Lineitem col = Gradebook.getColumn(courseId, contentId, true);
      if (col != null) {
        Utils.checkLineItemTitle(content.getId(), col);
      }
/*
      if (col == null) {
        pageContext.setAttribute("colMessage",
           String.format(b2Context.getResourceString("page.content.step1.message"), "???"));
      } else {
        pageContext.setAttribute("colMessage",
           String.format(b2Context.getResourceString("page.content.step1.message"), col.getName()));
      }
*/
    }
  }
  Utils.log(Verbosity.INFORMATION, "Exiting instance.jsp");

%>
<bbNG:pageHeader instructions="${bundle['page.content.create.description']}">
<%
  if (!mode.equals(Constants.MODE_MODIFY)) {
%>
  <bbNG:breadcrumbBar>
    <bbNG:breadcrumb title="${bundle['page.content.create.title']}" />
  </bbNG:breadcrumbBar>
  <bbNG:pageTitleBar title="${bundle['page.content.create.title']}" />
<%
  } else {
%>
  <bbNG:breadcrumbBar>
    <bbNG:breadcrumb title="${bundle['page.content.modify.title']}" />
  </bbNG:breadcrumbBar>
  <bbNG:pageTitleBar title="${bundle['page.content.modify.title']}" />
<%
  }
%>
</bbNG:pageHeader>
<bbNG:form action="" method="post" onsubmit="return validateForm();">
<bbNG:dataCollection markUnsavedChanges="true" showSubmitButtons="true">
  <bbNG:step hideNumber="false" title="${bundle['page.content.step1.title']}">
<%
/*
  if (mode.equals(Constants.MODE_MODIFY)) {
% >
    <div class="stepcontent">${colMessage}</div>
< %
  }
*/
%>
    <bbNG:dataElement isRequired="true" label="${bundle['page.content.step1.name.label']}">
      <bbNG:textElement type="string" name="<%=Constants.TITLE_PARAMETER%>" value="${params.title}" minLength="1" size="50" helpText="${bundle['page.content.step1.name.description']}" />
    </bbNG:dataElement>
    <bbNG:dataElement isRequired="false" label="${bundle['page.content.step1.description.label']}">
      <bbNG:textbox name="${params.descriptionname}" format="${params.descriptiontype}" text="${params.descriptiontext}" helpText="${bundle['page.content.step1.description.description']}" />
    </bbNG:dataElement>
    <bbng:dataElement isRequired="true" label="Allow Unlimited">
      <bbNG:checkboxElement name="<%=Constants.ALLOW_UNLIMITED%>" value="true" isSelected="${params.allowunlimited}" helpText="Enable unlimited retries if already validated."></bbNG:checkboxElement>
    </bbng:dataElement>
  </bbNG:step>
  <bbNG:stepSubmit hideNumber="false" showCancelButton="true" cancelUrl="<%=cancelUrl%>" />
</bbNG:dataCollection>
</bbNG:form>
</bbNG:learningSystemPage>
