<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2013  BSI

    Version history:
      1.0.4  29-Jan-13  Added to release
      1.0.6  16-Jun-13
      1.0.7  18-Jun-13
      1.0.8  27-Jun-13
      1.0.9  14-Jul-13
      1.1.0  17-Feb-14
--%>
<%@page contentType="application/json" pageEncoding="UTF-8"
        import="blackboard.platform.log.LogService.Verbosity,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.biosig_id.blackboard.InboundSSO,
                com.biosig_id.blackboard.Utils"
        errorPage="../error.jsp" %>
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering ch/redirect.jsp");

  String json;

  Utils.log(Verbosity.INFORMATION, "Get SSO redirect URL");
  InboundSSO sso = new InboundSSO(b2Context);
  String url = sso.getSession();
  if (url != null) {
    Utils.log(Verbosity.INFORMATION, "Redirecting to SSO redirect URL " + url);
    json = "{success: true, url: \"" + url + "\"}";
  } else {
    String message = sso.getMessage();
    if (message == null) {
      message = b2Context.getResourceString("page.view.error.message");
    }
    json = "{success: false, message: \"" + String.format(b2Context.getResourceString("page.view.bsi.message"), message) + "\"}";
  }
  Utils.log(Verbosity.INFORMATION, json);
  response.getWriter().print(json);

  Utils.log(Verbosity.INFORMATION, "Exiting ch/redirect.jsp");
%>
