<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2013  BSI

    Version history:
      1.0.0  01-Aug-11  First release
      1.0.1  22-Aug-11
      1.0.2   3-Nov-11  Added catch for exception with decryptString()
      1.0.4  29-Jan-13  Added type declaration to params Map
      1.0.6  16-Jun-13
      1.0.7  18-Jun-13
      1.0.8  27-Jun-13
      1.0.9  14-Jul-13
      1.1.0  17-Feb-14
--%>
<%@page contentType="text/xml" pageEncoding="UTF-8"
        import="java.util.Map,
                java.util.HashMap,
                java.util.Date,
                java.text.SimpleDateFormat,
                java.util.TimeZone,
                blackboard.platform.log.LogService.Verbosity,
                blackboard.persist.Id,
                blackboard.platform.persistence.PersistenceServiceFactory,
                blackboard.persist.PersistenceException,
                blackboard.platform.config.BbConfig,
                blackboard.persist.BbPersistenceManager,
                blackboard.data.content.Content,
                blackboard.persist.content.ContentDbLoader,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.bsid.common.AESKey,
                com.bsid.common.AESEncryption,
                com.biosig_id.blackboard.Constants,
                com.biosig_id.blackboard.Utils,
                com.biosig_id.blackboard.Gradebook"
        errorPage="../error.jsp" %>
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering ch/return.jsp");
  String args = b2Context.getRequestParameter("args", "");
  AESKey key = new AESKey();
  key.setPassPhrase(b2Context.getSetting(Constants.PASS_PHRASE_PARAMETER, ""));
  key.setSaltValue(b2Context.getSetting(Constants.SALT_PARAMETER, ""));
  key.setVector(b2Context.getSetting(Constants.VECTOR_PARAMETER, ""));
  String decrypted = "";
  try {
    decrypted = AESEncryption.decryptString(args, key, 128);
  } catch (Exception e) {
    decrypted = "";
  }

  String[] argArray = decrypted.split("&");
  Map<String,String> params = new HashMap<String,String>();
  for (int i = 0; i < argArray.length; i++) {
    String[] param = argArray[i].split("=", 2);
    if (param.length == 2) {
      params.put(param[0], param[1]);
    }
  }

  String status = null;
  String statusCode = null;
  String courseId = "";
  String contentId = "";
  String mode = "";
  String redirectURL = "";

  SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
  dateFormat.setTimeZone(TimeZone.getTimeZone("UTC"));
  String timestamp = dateFormat.format(System.currentTimeMillis());

  String[] data = null;
  boolean ok = params.containsKey(Constants.DATA_DATA_PARAMETER);
  if (ok) {
    data = params.get(Constants.DATA_DATA_PARAMETER).split(";", 3);
    ok = data.length == 3;
  }
  if (ok) {
    courseId = data[0];
    contentId = data[1];
    mode = data[2];
    ok = ((mode.length() <= 0) || mode.equals("ajax") || mode.equals("view") || mode.startsWith("course") ||
           mode.equals("content") || mode.startsWith("question") || mode.startsWith("jump") || mode.equals("submit")) &&
         params.containsKey("ts") &&
         params.containsKey("lc") && params.containsKey("nw") &&
         params.containsKey("em") && params.containsKey("fn") &&
         params.containsKey("ln") && params.containsKey("vs") &&
         params.containsKey("vl") && params.containsKey("uid");
  }
  if (ok) {
    Date convertedDate = dateFormat.parse(params.get("ts"));
    ok = (Math.abs(convertedDate.getTime() - System.currentTimeMillis()) <= Constants.MAX_TIMESTAMP_DIFF);
    if (!ok) {
      statusCode = "250";
    }
  }
  if (ok) {
    ok = params.containsKey("sc") &&
         (params.get("sc")).equals(b2Context.getSetting(Constants.SHARED_CODE_PARAMETER));
    if (!ok) {
      statusCode = "120";
    }
  }
  if (ok) {
    ok = params.containsKey("sid") &&
         (params.get("sid")).equals(b2Context.getSetting(Constants.SYSTEM_ID_PARAMETER));
    if (!ok) {
      statusCode = "140";
    }
  }
  if (ok) {
    ok = params.containsKey("cid") &&
         (params.get("cid")).equals(b2Context.getSetting(Constants.CUSTOMER_ID_PARAMETER));
    if (!ok) {
      statusCode = "150";
    }
  }
  if (ok) {
    String vl = params.get("vl");
    ok = (vl.equals("1") || vl.equals("2") || vl.equals("3") || vl.equals("4"));
    if (!ok) {
      statusCode = "110";
    }
  }
  if (ok) {
    ok = params.get("vs").equalsIgnoreCase("true");
    if (!ok) {
      statusCode = "110";
    }
  }
  if (ok) {
    boolean bioSightActive = false;
	if (params.containsKey("bsa")) {
		bioSightActive = params.get("bsa").equalsIgnoreCase("true");
	}
	Utils.log(Verbosity.INFORMATION, "BioSight Active: " + Boolean.toString(bioSightActive));
	String bioSightIndicator = (bioSightActive) ? "?q1" : "";

    status = "Success";
    statusCode = "100";
    Utils.log(Verbosity.INFORMATION, "Processing return for mode '" + mode + "'");
    if (mode.equals("content")) {
      redirectURL = b2Context.getServerUrl() + b2Context.getPath() + "begin.jsp" + bioSightIndicator;
    } else if (mode.startsWith("course")) {
      redirectURL = b2Context.getServerUrl() +  b2Context.getPath() + "course.jsp?courseid=" + mode.substring(6);
    } else if (mode.startsWith("question")) {
      redirectURL = b2Context.getServerUrl() +  b2Context.getPath() + "question.jsp?question=" + mode.substring(8);
    } else if (mode.startsWith("jump")) {
      redirectURL = b2Context.getServerUrl() +  b2Context.getPath() + "jump.jsp?question=" + mode.substring(4);
    } else if (mode.equals("submit")) {
      redirectURL = b2Context.getServerUrl() +  b2Context.getPath() + "submit.jsp";
    } else {
      BbPersistenceManager bbPm = PersistenceServiceFactory.getInstance().getDbPersistenceManager();
      Id id = bbPm.generateId(Content.DATA_TYPE, contentId);
      ContentDbLoader courseDocumentLoader = (ContentDbLoader)bbPm.getLoader(ContentDbLoader.TYPE);
      Content content = courseDocumentLoader.loadById(id);
      redirectURL = b2Context.getServerUrl() + b2Context.getNavigationItem("cp_content_quickdisplay").getHref();
      redirectURL = redirectURL.replace("@X@course.pk_string@X@", courseId);
      redirectURL = redirectURL.replace("@X@content.pk_string@X@", content.getParentId().toExternalString());
      redirectURL = redirectURL.replace("&", "&amp;");

      Utils.log(Verbosity.INFORMATION, "Updating gradebook");
      ok = Gradebook.updateGradebook(courseId, contentId, params.get("uid"));
      Utils.log(Verbosity.INFORMATION, "Gradebook updated");
    }

  } else {
    status = "Failure";
    if (mode.equals("content") || mode.equals("course")) {
      redirectURL = b2Context.getServerUrl() + b2Context.getPath() + "error2.jsp";
    } else {
      redirectURL = b2Context.getServerUrl() + b2Context.getPath() + "ch/error.jsp" +
                       "?course_id=" + courseId + "&amp;content_id=" + contentId;
    }
  }
  String message = Constants.errorCodes.get(statusCode);
  if (!ok) {
    System.err.println("biosig-id return error: " + message + " (" + statusCode + ")");
  }

  String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
               "<SSO_RESPONSE>\n" +
               "  <TIMESTAMP>" + timestamp + "</TIMESTAMP>\n" +
               "  <STATUS>" + status + "</STATUS>\n" +
               "  <CODE>" + statusCode + "</CODE>\n" +
               "  <MESSAGE>" + message + "</MESSAGE>\n" +
               "  <REDIRECT>" + redirectURL + "</REDIRECT>\n" +
               "</SSO_RESPONSE>";
  response.setContentType("text/xml");
  out.print(xml);
  Utils.log(Verbosity.INFORMATION, "Response:\n" + xml);
  Utils.log(Verbosity.INFORMATION, "Exiting ch/return.jsp");

%>