<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2013  BSI

    Version history:
      1.0.0  01-Aug-11  First release
      1.0.1  22-Aug-11  Fixed bug which expected all users to be enrolled in course
      1.0.2   3-Nov-11
      1.0.4  29-Jan-13  Added docType and contentType
      1.0.6  16-Jun-13
      1.0.7  18-Jun-13
      1.0.8  27-Jun-13
      1.0.9  14-Jul-13  Check content render type is REGULAR
                        Check line item title matches content title
      1.1.0  17-Feb-14
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@page contentType="text/html" pageEncoding="UTF-8"
        import="blackboard.platform.log.LogService.Verbosity,
                blackboard.persist.Id,
                blackboard.data.course.CourseMembership,
                blackboard.persist.course.CourseMembershipDbLoader,
                blackboard.data.content.Content,
                blackboard.persist.content.ContentDbLoader,
                blackboard.persist.content.ContentDbPersister,
                blackboard.data.gradebook.Score,
                blackboard.persist.BbPersistenceManager,
                blackboard.platform.persistence.PersistenceServiceFactory,
                blackboard.platform.config.BbConfig,
                blackboard.persist.course.CourseDbLoader,
                blackboard.persist.gradebook.ScoreDbLoader,
                blackboard.persist.course.CourseMembershipDbLoader,
                blackboard.persist.KeyNotFoundException,
                blackboard.persist.PersistenceException,
                blackboard.data.gradebook.Lineitem,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.biosig_id.blackboard.Constants,
                com.biosig_id.blackboard.Utils,
                com.biosig_id.blackboard.Gradebook" %>
<%@ page import="blackboard.platform.plugin.PlugInUtil" %>
<%@taglib uri="/bbNG" prefix="bbNG" %>
<bbNG:learningSystemPage>
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering view.jsp");

  Utils.log(Verbosity.INFORMATION, "Load course membership");
  CourseMembershipDbLoader loader = null;
  try {
    loader = CourseMembershipDbLoader.Default.getInstance();
  } catch (PersistenceException e) {
    loader = null;
  }
  CourseMembership cm = null;
  if (loader != null) {
    try {
      cm = loader.loadByCourseAndUserId(
         b2Context.getContext().getCourseId(), b2Context.getContext().getUserId());
    } catch (KeyNotFoundException e) {
      cm = null;
    } catch (PersistenceException e) {
      cm = null;
    }
  }
  String courseId = b2Context.getRequestParameter(Constants.COURSE_ID_PARAM_NAME, "");
  String contentId = b2Context.getRequestParameter(Constants.CONTENT_ID_PARAM_NAME, "");
  BbPersistenceManager bbPm = PersistenceServiceFactory.getInstance().getDbPersistenceManager();
  ContentDbLoader courseDocumentLoader = (ContentDbLoader)bbPm.getLoader(ContentDbLoader.TYPE);
  Content content = courseDocumentLoader.loadById(bbPm.generateId(Content.DATA_TYPE, contentId));
  if (!content.getRenderType().equals(Content.RenderType.REGULAR)) {
    content.setRenderType(Content.RenderType.REGULAR);
    content.setUrl(null);
    ContentDbPersister persister = (ContentDbPersister)bbPm.getPersister(ContentDbPersister.TYPE);
    persister.persist(content);
  }

  Boolean allowunlimited = b2Context.getSetting(false, true, Constants.ALLOW_UNLIMITED, Constants.DATA_FALSE).equals("true");

  if ((cm != null) && cm.getRole().equals(CourseMembership.Role.STUDENT)) {

    if (Utils.isInstitution((b2Context)))
    {
      // user is not in a configured institution role
      Id uid = b2Context.getContext().getUserId();

      //  auto set grade
      try {
        Gradebook.updateGradebook(courseId, contentId, uid.getExternalString(), true);
      } catch (PersistenceException e) {
        Utils.log(Verbosity.INFORMATION, "Blackboard no workie workie");
      }

      // get parent id
      Id parent = content.getParentId();

      // build relative redirect url
      String url = PlugInUtil.getContentReturnURL(parent.getExternalString(), courseId);

      // redirect back to content
      response.sendRedirect(url);
    }
    else
    {
      Utils.log(Verbosity.INFORMATION, "Load gradebook column");
      Score score = null;
      Lineitem lineitem = null;
      lineitem = Gradebook.getColumn(courseId, contentId, false);

      if (lineitem != null) {
        Utils.checkLineItemTitle(content.getId(), lineitem);
        try {
          Id cid = b2Context.getContext().getCourseId();
          Id uid = b2Context.getContext().getUserId();
          CourseMembershipDbLoader coursemembershipdbloader = (CourseMembershipDbLoader) bbPm.getLoader(CourseMembershipDbLoader.TYPE);
          CourseMembership coursemembership = coursemembershipdbloader.loadByCourseAndUserId(cid, uid);
          ScoreDbLoader scoredbloader = (ScoreDbLoader) bbPm.getLoader(ScoreDbLoader.TYPE);
          score = scoredbloader.loadByCourseMembershipIdAndLineitemId(coursemembership.getId(), lineitem.getId());
        } catch (KeyNotFoundException e) {
          score = null;
        } catch (PersistenceException e) {
          score = null;
        }
      }
      if (allowunlimited || (score == null) || (score.getGrade().trim().equals(""))) {
        pageContext.setAttribute("title", b2Context.getResourceString("page.view.redirect.message"));
        pageContext.setAttribute("redirectUrl", "redirect.jsp?" + request.getQueryString());
%>
  <bbNG:jsFile href="/javascript/scriptaculous/effects.js"/>
  <bbNG:jsFile href="/javascript/ngui/lightbox.js"/>
  <bbNG:jsBlock>
<script language="javascript" type="text/javascript">
var bsi_lb = new lightbox.Lightbox({
   dimensions : { w : 250, h : 150 },
   closeOnBodyClick : false,
   showCloseLink : false,
   title : "${title}",
   ajax : { url: "${redirectUrl}", method: "GET", asyn : true, loadExternalScripts: true }
});
bsi_lb.open(bsi_session);
function bsi_session() {
  var response = bsi_lb.lightboxContent.innerHTML;
  bsi_lb.lightboxContent.innerHTML = '';
  var pos = response.indexOf('</div>');
  if (pos >= 0) {
    response = response.substr(pos + 6);
  }
  var pos = response.indexOf('</DIV>');
  if (pos >= 0) {
    response = response.substr(pos + 6);
  }
	var json = eval ("(" + response + ")");
	if (json.success) {
    location.href = json.url;
  } else {
    bsi_lb.close();
    alert(json.message);
    window.history.back();
  }
}
</script>
  </bbNG:jsBlock>
<%
      } else {
        //pageContext.setAttribute("message", b2Context.getResourceString("page.view.student.message"));

        // get parent id
        Id parent = content.getParentId();

        // build relative redirect url
        String url = PlugInUtil.getContentReturnURL(parent.getExternalString(), courseId);

        // redirect back to content
        response.sendRedirect(url);
      }
    }
  } else {
    String msg = b2Context.getResourceString("page.view.staff.message");
    msg += "<br /><br />";
    msg += "Students are allowed to do unlimited retries: ";
    msg += allowunlimited ? "yes" : "no";
    pageContext.setAttribute("message", msg);
  }
  Utils.log(Verbosity.INFORMATION, "Exiting view.jsp");
%>
<p>
${message}
</p>
</bbNG:learningSystemPage>
