<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2015  BSI

    Version history:
      2.0.0  29-Sep-15  Added to project
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@page contentType="text/html" pageEncoding="UTF-8"
        import="java.text.SimpleDateFormat,
                java.util.TimeZone,
                blackboard.platform.log.LogService.Verbosity,
                blackboard.platform.session.BbSession,
                blackboard.platform.session.BbSessionManagerServiceFactory,
                blackboard.persist.PersistenceException,
                com.biosig_id.blackboard.Utils,
                com.spvsoftwareproducts.blackboard.utils.B2Context" %>
<%@taglib uri="/bbNG" prefix="bbNG" %>
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering course.jsp");

  SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
  dateFormat.setTimeZone(TimeZone.getTimeZone("UTC"));
  String timestamp = dateFormat.format(System.currentTimeMillis());
  String name = b2Context.getVendorId() + "-" + b2Context.getHandle() + "-course-timestamp";
  try {
    BbSession bbSession = BbSessionManagerServiceFactory.getInstance().getSession(request);
    Utils.log(Verbosity.INFORMATION, "Set session key: " + name + "=" + timestamp);
    bbSession.setGlobalKey(name, timestamp);
  } catch (PersistenceException e) {
    Utils.log(Verbosity.INFORMATION, "Unable to save session key: " + name + "=" + timestamp);
    Utils.log(Verbosity.ERROR, e.getMessage());
  } catch (Exception e) {
    Utils.log(Verbosity.ERROR, "Unable to get session: " + e.getMessage());
  }

  String url = "/webapps/blackboard/execute/launcher?type=Course&id=" + b2Context.getRequestParameter("courseid", "");

  pageContext.setAttribute("bundle", b2Context.getResourceStrings());
  pageContext.setAttribute("url", url);

  Utils.log(Verbosity.INFORMATION, "Exiting course.jsp");
%>
<html>
<head>
<title>${bundle['plugin.name']}</title>
<script language="javascript" type="text/javascript">
//<![CDATA[
function doOnLoad() {
	parent.location.href = '${url}';
}
window.onload=doOnLoad;
//]]>
</script>
</head>
<body>
</body>
</html>
