<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2015  BSI

    Version history:
      2.0.0  11-Jan-15  Added to project
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@page contentType="text/html" pageEncoding="UTF-8"
        import="java.net.URLEncoder,
                blackboard.platform.log.LogService.Verbosity,
                com.biosig_id.blackboard.Utils,
                java.io.UnsupportedEncodingException,
                blackboard.data.navigation.NavigationItem,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.biosig_id.blackboard.Constants"
        errorPage="../error.jsp"%>
<%@taglib uri="/bbNG" prefix="bbNG" %>
<bbNG:learningSystemPage title="${bundle['plugin.name']}" entitlement="course.control_panel.VIEW">
<%
  B2Context b2Context = new B2Context(request);
  b2Context.clearNode();
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering course/config.jsp");
  String courseId = b2Context.getContext().getCourseId().toExternalString();
  String coursesEnabled = "," + b2Context.getSetting(Constants.COURSE_ENABLE_PARAMETER, "");
  if (coursesEnabled.length() > 1) {
    coursesEnabled += ",";
  }
  boolean isEnabled = coursesEnabled.contains("," + courseId + ",");
  boolean disabled = b2Context.getSetting(Constants.FORCE_COURSE_PARAMETER, "false").equals("true");

  if (disabled) {
    isEnabled = true;
  } else if (request.getMethod().equalsIgnoreCase("POST")) {
    boolean enable = b2Context.getRequestParameter(Constants.COURSE_ENABLE_PARAMETER, String.valueOf(false)).equals(String.valueOf(true));
    if (isEnabled ^ enable) {
      if (enable) {
        coursesEnabled = coursesEnabled.substring(1, coursesEnabled.length()) + courseId;
      } else {
        coursesEnabled = coursesEnabled.replaceAll("," + courseId + ",", ",");
        if (coursesEnabled.length() <= 2) {
          coursesEnabled = "";
        } else {
          coursesEnabled = coursesEnabled.substring(1, coursesEnabled.length() - 1);
        }
      }
      b2Context.setSaveEmptyValues(false);
      b2Context.setSetting(Constants.COURSE_ENABLE_PARAMETER, coursesEnabled);
      b2Context.persistSettings();
      isEnabled = enable;
    }
  }
  if (request.getMethod().equalsIgnoreCase("POST")) {
    boolean reset = b2Context.getRequestParameter(Constants.RESET_PARAMETER, "false").equals("true");
    if (reset) {
      b2Context.setSetting(false, true, Constants.TESTS_PARAMETER, null);
      b2Context.setSetting(false, true, Constants.TEST_BEGIN_PARAMETER, null);
      b2Context.setSetting(false, true, Constants.TEST_USERS_PARAMETER, null);
      b2Context.setSetting(false, true, Constants.TEST_END_PARAMETER, null);
      b2Context.setReceipt(b2Context.getResourceString("page.receipt.reset"));
    } else {
      b2Context.setSetting(false, true, Constants.TESTS_PARAMETER, b2Context.getRequestParameter(Constants.TESTS_PARAMETER, "false"));
      b2Context.setSetting(false, true, Constants.TEST_BEGIN_PARAMETER, b2Context.getRequestParameter(Constants.TEST_BEGIN_PARAMETER, "false"));
      b2Context.setSetting(false, true, Constants.TEST_USERS_PARAMETER, b2Context.getRequestParameter(Constants.TEST_USERS_PARAMETER, "0"));
      b2Context.setSetting(false, true, Constants.TEST_END_PARAMETER, b2Context.getRequestParameter(Constants.TEST_END_PARAMETER, "false"));
      b2Context.setReceipt(b2Context.getResourceString("page.receipt.success"));
    }
    b2Context.persistSettings(false, true);
  }

  int testUsers = 0;
  testUsers = Integer.parseInt(b2Context.getSetting(false, true, Constants.TEST_USERS_PARAMETER, b2Context.getSetting(Constants.TEST_USERS_PARAMETER, "0")));
  pageContext.setAttribute("tests", b2Context.getSetting(false, true, Constants.TESTS_PARAMETER, b2Context.getSetting(Constants.TESTS_PARAMETER, "false")));
  pageContext.setAttribute("testbegin", b2Context.getSetting(false, true, Constants.TEST_BEGIN_PARAMETER, b2Context.getSetting(Constants.TEST_BEGIN_PARAMETER, "false")));
  pageContext.setAttribute("testend", b2Context.getSetting(false, true, Constants.TEST_END_PARAMETER, b2Context.getSetting(Constants.TEST_END_PARAMETER, "false")));

  pageContext.setAttribute("bundle", b2Context.getResourceStrings());
  pageContext.setAttribute(Constants.COURSE_ENABLE_PARAMETER, String.valueOf(isEnabled));
  pageContext.setAttribute("disabled", String.valueOf(disabled));

  Utils.log(Verbosity.INFORMATION, "Exiting course/config.jsp");
%>
  <bbNG:pageHeader instructions="${bundle['page.system.instructions']}">
    <bbNG:breadcrumbBar environment="SYS_ADMIN_PANEL" navItem="admin_plugin_manage">
      <bbNG:breadcrumb>${bundle['plugin.name']}</bbNG:breadcrumb>
    </bbNG:breadcrumbBar>
    <bbNG:pageTitleBar iconUrl="../images/bsi.png" showTitleBar="true" title="${bundle['plugin.name']}"/>
  </bbNG:pageHeader>
  <bbNG:form action="" id="configForm" name="configForm" method="post" onsubmit="return validateForm();">
  <bbNG:dataCollection markUnsavedChanges="true" showSubmitButtons="true">
    <bbNG:step hideNumber="false" id="stepOne" title="${bundle['page.course_tool.step1.title']}" instructions="${bundle['page.course_tool.step1.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.course_tool.step1.courseenable.label']}">
        <bbNG:checkboxElement isDisabled="${disabled}" isSelected="${courseenable}" name="<%=Constants.COURSE_ENABLE_PARAMETER%>" value="true" helpText="${bundle['page.course_tool.step1.courseenable.instructions']}" />
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:step hideNumber="false" id="stepTwo" title="${bundle['page.course_tool.step2.title']}" instructions="${bundle['page.course_tool.step2.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testlaunch.label']}">
        <bbNG:checkboxElement isSelected="${tests}" name="<%=Constants.TESTS_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testlaunch.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testbegin.label']}">
        <bbNG:checkboxElement isSelected="${testbegin}" name="<%=Constants.TEST_BEGIN_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testbegin.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testusers.label']}">
        <bbNG:selectElement isRequired="true" name="<%=Constants.TEST_USERS_PARAMETER%>" helpText="${bundle['page.system.step4.testusers.instructions']}">
<%
    String str;
    String strLabel;
    boolean selected;
    for (int i = 0; i <= 100; i++) {
      str = String.valueOf(i);
      strLabel = str + '%';
      selected = (i == testUsers);
%>
          <bbNG:selectOptionElement isSelected="<%=selected%>" value="<%=str%>" optionLabel="<%=strLabel%>" />
<%
    }
%>
        </bbNG:selectElement>
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testend.label']}">
        <bbNG:checkboxElement isSelected="${testend}" name="<%=Constants.TEST_END_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testend.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isSubElement="true" subElementType="INDENTED_NESTED_LIST">
        <bbNG:dataElement isRequired="false" label="${bundle['page.course_tool.step2.reset.label']}">
          <bbNG:checkboxElement name="<%=Constants.RESET_PARAMETER%>" value="true" onClick="JavaScript: return confirm('${bundle['page.message.confirm']}');" helpText="${bundle['page.course_tool.step2.reset.instructions']}" />
        </bbNG:dataElement>
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:stepSubmit hideNumber="false" showCancelButton="false" />
  </bbNG:dataCollection>
  </bbNG:form>
</bbNG:learningSystemPage>
