<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2015  BSI

    Version history:
      2.0.0  26-Sep-15  Added to project
--%>
<%@page import="blackboard.platform.log.LogService.Verbosity"%>
<%@page contentType="text/javascript" pageEncoding="UTF-8"
        import="java.util.List,
                java.util.ArrayList,
                java.util.Map,
                java.util.Iterator,
                blackboard.base.BbList,
                blackboard.data.role.PortalRole,
                blackboard.platform.intl.BundleManagerFactory,
                blackboard.platform.intl.BbResourceBundle,
                blackboard.data.course.CourseMembership,
                blackboard.persist.PersistenceException,
                blackboard.persist.course.CourseMembershipDbLoader,
                blackboard.data.course.Course.ServiceLevel,
                blackboard.platform.session.BbSession,
                blackboard.platform.session.BbSessionManagerServiceFactory,
                com.biosig_id.blackboard.Constants,
                com.biosig_id.blackboard.Utils,
                com.spvsoftwareproducts.blackboard.utils.B2Context"
        errorPage="error.jsp"%>
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);

  BbResourceBundle bundle = BundleManagerFactory.getInstance().getBundle("portal_view");
  String loadMsg = bundle.getString("portalUtil.pleaseWaitMsg");
  StringBuilder challengeCourses = new StringBuilder();

  if (Utils.challengeUser(b2Context)) {
    boolean challenge = !b2Context.getSetting(Constants.FORCE_COURSE_PER_SESSION_PARAMETER, "false").equals("true");
    if (!challenge) {
      String name = b2Context.getVendorId() + "-" + b2Context.getHandle() + "-course-timestamp";
      try {
        BbSession bbSession = BbSessionManagerServiceFactory.getInstance().getSession(request);
        String timestamp = bbSession.getGlobalKey(name);
        challenge = (timestamp == null) || timestamp.isEmpty();
      } catch (Exception e) { // (PersistenceException e) {
        Utils.log(Verbosity.ERROR, e.getMessage());
      }
    }
    if (challenge) {
      if (b2Context.getSetting(Constants.FORCE_COURSE_PARAMETER, "false").equals("true")) {
        challengeCourses.append(",*");
      } else {
        CourseMembershipDbLoader courseLoader = CourseMembershipDbLoader.Default.getInstance();
        List<CourseMembership.Role> roles = new ArrayList<CourseMembership.Role>();
        roles.add(CourseMembership.Role.STUDENT);
        roles.add(CourseMembership.Role.GUEST);
        roles.add(CourseMembership.Role.NONE);
        BbList<CourseMembership> courses = courseLoader.loadByUserIdAndRoles(b2Context.getContext().getUserId(), ServiceLevel.DEFAULT, roles);
        if (courses.size() > 0) {
          String coursesEnable = "," + b2Context.getSetting(Constants.COURSE_ENABLE_PARAMETER, "") + ",";
          CourseMembership courseMembership;
          String courseId;
          for (Iterator<CourseMembership> iter = courses.iterator(); iter.hasNext();) {
            courseMembership = iter.next();
            courseId = courseMembership.getCourseId().toExternalString();
            if (coursesEnable.contains("," + courseId + ",")) {
              challengeCourses.append(",").append(courseId);
            }
          }
        }
      }
    }
  }

  if (challengeCourses.length() > 0) {
    pageContext.setAttribute("vendor", b2Context.getVendorId());
    pageContext.setAttribute("loadMsg", loadMsg);
    pageContext.setAttribute("courseids", b2Context.getSetting(Constants.COURSE_ENABLE_PARAMETER, ""));
    pageContext.setAttribute("ids", challengeCourses.substring(1));
%>
var bsi_course_timer;
var bsi_course_divs = new Array();
var bsi_course_ids = ',${ids},';
Event.observe(document,"dom:loaded", function() {
  $$('div.collapsible div').each(function(item) {
    if (item.innerHTML === '${loadMsg}') {
      bsi_course_divs.push(item);
    }
  });
  $$('a[href*="/webapps/blackboard/execute/launcher"]').each(function(item) {
    ${vendor}_checkLink(item);
  });
  if (bsi_course_divs.length > 0) {
    bsi_course_timer = window.setInterval(${vendor}_onClickCourse, 500);
  }
});

if(!globalNavMenu._goToUrlOrig) globalNavMenu._goToUrlOrig = globalNavMenu.goToUrl;

globalNavMenu.goToUrl = function(url) {
 if(url.toQueryParams().type == 'Course') {
  var id = url.toQueryParams().id;
    if ((bsi_course_ids == ',*,') || (bsi_course_ids.indexOf(',' + id + ',') >= 0)) {
       ${vendor}_idCheck({stop: function(){}}, 'course' + id);
       return;
    }
 }
 globalNavMenu._goToUrlOrig(url);
};

function ${vendor}_onClickCourse(event) {
  var divs = new Array();
  bsi_course_divs.each(function(item) {
    if (item.innerHTML === '${loadMsg}') {
      divs.push(item);
    } else {
      $$('div#' + item.id + ' a[href*="/webapps/blackboard/execute/launcher"]').each(function(item) {
        ${vendor}_checkLink(item);
      });
    }
  });
  if (divs.length > 0) {
    bsi_course_divs = divs;
  } else {
    window.clearTimeout(bsi_course_timer);
  }
}

function ${vendor}_checkLink(item) {
  var id = item.href.toQueryParams().id;
  if ((bsi_course_ids == ',*,') || (bsi_course_ids.indexOf(',' + id + ',') >= 0)) {
    item.onclick = ${vendor}_courseIdCheck;
  }
}

function ${vendor}_courseIdCheck(event) {
  var id = event.currentTarget.href.toQueryParams().id;
  ${vendor}_idCheck(event, 'course' + id);
}
<%
  }
%>