<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2015  BSI

    Version history:
      2.0.0  11-Jan-15  Added to project
--%>
<%@page import="blackboard.platform.log.LogService.Verbosity"%>
<%@page contentType="text/javascript" pageEncoding="UTF-8"
        import="java.util.Map,
                java.util.Iterator,
                blackboard.persist.navigation.CourseContentHandlersDbLoader,
                blackboard.data.navigation.CourseContentHandler,
                blackboard.platform.session.BbSession,
                blackboard.platform.session.BbSessionManagerServiceFactory,
                blackboard.persist.PersistenceException,
                blackboard.platform.config.BbConfig,
                com.biosig_id.blackboard.Constants,
                com.biosig_id.blackboard.Utils,
                com.spvsoftwareproducts.blackboard.utils.B2Context"
        errorPage="error.jsp"%>
<%
	B2Context b2Context = new B2Context(request);

	boolean ok = Utils.challengeUser(b2Context);
	if (ok) {
		CourseContentHandlersDbLoader cchLoader = CourseContentHandlersDbLoader.Default.getInstance();
		CourseContentHandler cch = cchLoader.loadByHandleAndCourseId(Constants.RESOURCE_HANDLE, b2Context.getContext().getCourseId());
		ok = cch.getIsAvailable();
	}

	// START#32
	if (ok) {
		b2Context.setIgnoreContentContext(true);
		String defaultEnable = b2Context.getSetting(false, true, Constants.TESTS_PARAMETER, b2Context.getSetting(Constants.TESTS_PARAMETER, "false"));
		boolean defaultTestBegin = b2Context.getSetting(false, true, Constants.TEST_BEGIN_PARAMETER, b2Context.getSetting(Constants.TEST_BEGIN_PARAMETER, "false")).equals("true");
		boolean defaultTestUsers = !b2Context.getSetting(false, true, Constants.TEST_USERS_PARAMETER, b2Context.getSetting(Constants.TEST_USERS_PARAMETER, "0")).equals("0");
		boolean defaultTestEnd = b2Context.getSetting(false, true, Constants.TEST_END_PARAMETER, b2Context.getSetting(Constants.TEST_END_PARAMETER, "false")).equals("true");

		StringBuilder ids = new StringBuilder();
		Map.Entry<String,String> entry;
		Map<String,String> settings = b2Context.getSettings(false, true);
		for (Iterator<Map.Entry<String,String>> iter = settings.entrySet().iterator(); iter.hasNext();) {
			entry = iter.next();
			if (!entry.getValue().equals(defaultEnable)) {
				ids.append(",").append(entry.getKey());
			}
		}
		if (ids.length() <= 0) {
			ids.append(",");
		}
		String question = null;
		if (defaultTestUsers) {
			BbSession bbSession = BbSessionManagerServiceFactory.getInstance().getSession(b2Context.getRequest());
			String name = b2Context.getVendorId() + "-" + b2Context.getHandle() + "-" + "question";
			try {
				question = bbSession.getGlobalKey(name);
			} catch (Exception e) {
			}
			if ((question == null) || question.isEmpty()) {
				defaultTestUsers = false;
			}
		}

		pageContext.setAttribute("bundle", b2Context.getResourceStrings());
		pageContext.setAttribute("vendor", b2Context.getVendorId());
		pageContext.setAttribute("path", b2Context.getPath());
		pageContext.setAttribute("defaultEnable", defaultEnable);
		pageContext.setAttribute("ids", ids.substring(1));
		pageContext.setAttribute("question", question);
%>
var bsi_default = ${defaultEnable};
var bsi_content_ids = ',${ids},';
var bsi_menutext = '${bundle['page.render.menu']}';
var bsi_enabledtext = '${bundle['page.render.enabled']}';
var bsi_disabledtext = '${bundle['page.render.disabled']}';

<%
		if (defaultTestBegin) {
%>
Event.observe(document,"dom:loaded", function() {
	$$('input[onclick*="clickOnBegin"]').invoke('stopObserving', 'click');
	$$('input[onclick*="clickOnBegin"]').invoke('observe', 'click', ${vendor}_beginIdCheck);
	$$('input[onclick*="clickOnBegin"]').each(function(item) {
		item.onclick = null;
	});
});

function ${vendor}_beginIdCheck(event) {
	var id = document.URL.toQueryParams().content_id;
	var enabled = bsi_default;
	if (bsi_content_ids.indexOf(',' + id + ',') >= 0) {
		enabled = !enabled;
	}
	if (enabled) {
		${vendor}_idCheck(event, 'content');
	} else {
		clickOnBegin();
	}
}

<%
		}

		if (defaultTestUsers) {
%>
Event.observe(document,"dom:loaded", function() {
	$$('button[onclick*="navigate(\'question_num_${question}"]').invoke('stopObserving', 'click');
	$$('button[onclick*="navigate(\'question_num_${question}"]').invoke('observe', 'click', ${vendor}_questionIdCheck);
	$$('button[onclick*="navigate(\'question_num_${question}"]').each(function(item) {
		item.onclick = null;
	});
});
Event.observe(document,"dom:loaded", function() {
	$$('button[onclick*="jumpTo(\'${question}\')"]').invoke('stopObserving', 'click');
	$$('button[onclick*="jumpTo(\'${question}\')"]').invoke('observe', 'click', ${vendor}_jumpIdCheck);
	$$('button[onclick*="jumpTo(\'${question}\')"]').each(function(item) {
		item.onclick = null;
	});
});

function ${vendor}_questionIdCheck(event) {
	${vendor}_idCheck(event, 'question${question}');
}

function ${vendor}_jumpIdCheck(event) {
	${vendor}_idCheck(event, 'jump${question}');
}

<%
		}

		if (defaultTestEnd) {
%>
Event.observe(document,"dom:loaded", function() {
	$$('input[onclick*="doConfirmSubmit(submitAssessment)"]').invoke('stopObserving', 'click');
	$$('input[onclick*="doConfirmSubmit(submitAssessment)"]').invoke('observe', 'click', ${vendor}_submitIdCheck);
	$$('input[onclick*="doConfirmSubmit(submitAssessment)"]').each(function(item) {
		item.onclick = null;
	});
});

function ${vendor}_submitIdCheck(event) {
	${vendor}_idCheck(event, 'submit');
}

<%
		}

		int major = Utils.getMajorVersionNumber();
		
		if (major >= 3200) {
%>
function addToList(list, newItem) {
	var existing = window.jQuery(list).parents('div').find('ul li a[title^="' + bsi_menutext + '"]');
	if (existing.length == 0) {
		list.appendChild(newItem);
	}
}
<%
		} else {
%>
function addToList(list, newItem) {
	list.insertBefore(newItem, list.childNodes[0]);
}
<%
		}
%>


Event.observe(document,"dom:loaded", function() {
	// Process BSI code after DOM has loaded
<%
		if (major >= 3200) {
%>
	// Attach BSI code on each contextMenu chevron click action for quizzes (only needed for 3200+)
	window.jQuery('#content_listContainer li.liItem .item a[href^="/webapps/blackboard/content/launchAssessment"]').parents('.liItem').find('a.editmode[href="#contextMenu"]').on('click', function() {
<%
		}
%>
		setTimeout(function () {
			// Process all contextMenu links that match quiz identifier
			$$('a[id*="edit_assessment_"]').each(function(item) {
				var id = item.href.toQueryParams().content_id;
				if (id === undefined && 'ohref' in item)
				{
					id = item.ohref.toQueryParams().content_id;
				}
				var enable = bsi_default;
				if (bsi_content_ids.indexOf(',' + id + ',') >= 0) {
					enable = !enable;
				}
				var title = bsi_menutext;
				if (enable) {
					title += ' ' + bsi_enabledtext;
				} else {
					title += ' ' + bsi_disabledtext;
				}
				var list = $(item).up('ul');
				var newItem = document.createElement("LI");
				var link = document.createElement("A");
				link.href = '#';
				link.title = title;
				link.contentid = id;
				link.on("click", function(event) {
					var ok = false;
					var disable = this.innerHTML.indexOf(bsi_enabledtext) > 0;
					new Ajax.Request('${path}ch/status.jsp?course_id=' + document.URL.toQueryParams().course_id + '&contentid=' + this.contentid + '&set=' + !disable, {
						asynchronous: false,
						onSuccess: function(response) {
							if (response.status === 200) {
								if (response.responseJSON.response === 'Success') {
									ok = true;
									resp = response;
								} else {
									errormsg = response.responseJSON.reason;
								}
							}
						}
					});
					if (!ok) {
						alert('${bundle['page.render.error']}');
					} else {
						var newtitle = bsi_menutext;
						if (!disable) {
							newtitle += ' ' + bsi_enabledtext;
						} else {
							newtitle += ' ' + bsi_disabledtext;
						}
						this.innerHTML = newtitle;
						this.title = newtitle;
					}
				});
				newItem.appendChild(link);
				var text = document.createTextNode(title);
				link.appendChild(text);
				addToList(list, newItem)
			});
		}, 250);
<%
		if (major >= 3200) {
%>
	});
<%
		}
%>
});

<%
	}
	// END#32
	else {
%>
// Hybrid-Course: BioSig Disabled!
<%
	}
%>