<%--
    biosig-id - Building Block to verify an individual's identity
    Copyright (C) 2013  BSI

    Version history:
      1.0.0  01-Aug-11  First release
      1.0.2   3-Nov-11
      1.0.4  29-Jan-13  Updated receipt options for Learn 9.1 SP10
                        Added docType and contentType
      1.0.6  16-Jun-13
      1.0.7  18-Jun-13
      1.0.8  27-Jun-13
      1.0.9  14-Jul-13
      1.1.0  17-Feb-14 Added option for deleting gradebook column with content item
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@page contentType="text/html" pageEncoding="UTF-8"
        import="java.util.List,
                java.net.URLEncoder,
                blackboard.data.role.PortalRole,
                blackboard.platform.log.LogService.Verbosity,
                com.biosig_id.blackboard.Utils,
                java.io.UnsupportedEncodingException,
                blackboard.data.navigation.NavigationItem,
                com.spvsoftwareproducts.blackboard.utils.B2Context,
                com.biosig_id.blackboard.Constants"
        errorPage="../error.jsp"%>
<%@taglib uri="/bbNG" prefix="bbNG" %>
<bbNG:genericPage title="${bundle['page.system.title']}" entitlement="system.admin.VIEW">
<%
  B2Context b2Context = new B2Context(request);
  Utils.setLogger(b2Context);
  Utils.log(Verbosity.INFORMATION, "Entering system/config.jsp");

  String cancelUrl = b2Context.getNavigationItem("admin_plugin_manage").getHref();

  if (request.getMethod().equalsIgnoreCase("POST")) {
    b2Context.setSaveEmptyValues(false);
    b2Context.setSetting(Constants.URL_PARAMETER, b2Context.getRequestParameter(Constants.URL_PARAMETER, ""));
    b2Context.setSetting(Constants.SHARED_CODE_PARAMETER, b2Context.getRequestParameter(Constants.SHARED_CODE_PARAMETER, ""));
    b2Context.setSetting(Constants.SYSTEM_ID_PARAMETER, b2Context.getRequestParameter(Constants.SYSTEM_ID_PARAMETER, ""));
    b2Context.setSetting(Constants.CUSTOMER_ID_PARAMETER, b2Context.getRequestParameter(Constants.CUSTOMER_ID_PARAMETER, ""));
    b2Context.setSetting(Constants.DEFAULT_LOCALE_PARAMETER, b2Context.getRequestParameter(Constants.DEFAULT_LOCALE_PARAMETER, ""));
    b2Context.setSetting(Constants.BIOSIGHT_DOMAIN_PARAMETER, b2Context.getRequestParameter(Constants.BIOSIGHT_DOMAIN_PARAMETER, ""));

    b2Context.setSetting(Constants.PASS_PHRASE_PARAMETER, b2Context.getRequestParameter(Constants.PASS_PHRASE_PARAMETER, ""));
    b2Context.setSetting(Constants.SALT_PARAMETER, b2Context.getRequestParameter(Constants.SALT_PARAMETER, ""));
    b2Context.setSetting(Constants.VECTOR_PARAMETER, b2Context.getRequestParameter(Constants.VECTOR_PARAMETER, ""));

    b2Context.setSetting(Constants.TITLE_PARAMETER, b2Context.getRequestParameter(Constants.TITLE_PARAMETER, ""));
    b2Context.setSetting(Constants.DESCRIPTION_PARAMETER, b2Context.getRequestParameter(Constants.DESCRIPTION_PARAMETER + "text", ""));
    b2Context.setSetting(Constants.DESCRIPTION_TYPE_PARAMETER, b2Context.getRequestParameter(Constants.DESCRIPTION_TYPE_PARAMETER + "type", "H"));
    b2Context.setSetting(Constants.IROLES_PARAMETER, b2Context.getRequestParameterValues(Constants.IROLES_PARAMETER, ""));

    b2Context.setSetting(Constants.GRADEBOOK_PARAMETER, b2Context.getRequestParameter(Constants.GRADEBOOK_PARAMETER, ""));
    b2Context.setSetting(Constants.FORCE_COURSE_PARAMETER, b2Context.getRequestParameter(Constants.FORCE_COURSE_PARAMETER, ""));
    b2Context.setSetting(Constants.FORCE_COURSE_PER_SESSION_PARAMETER, b2Context.getRequestParameter(Constants.FORCE_COURSE_PER_SESSION_PARAMETER, ""));
    b2Context.setSetting(Constants.TESTS_PARAMETER, b2Context.getRequestParameter(Constants.TESTS_PARAMETER, ""));
    b2Context.setSetting(Constants.TEST_BEGIN_PARAMETER, b2Context.getRequestParameter(Constants.TEST_BEGIN_PARAMETER, ""));
    b2Context.setSetting(Constants.TEST_USERS_PARAMETER, b2Context.getRequestParameter(Constants.TEST_USERS_PARAMETER, ""));
    b2Context.setSetting(Constants.TEST_END_PARAMETER, b2Context.getRequestParameter(Constants.TEST_END_PARAMETER, ""));

    b2Context.persistSettings();
    String receiptMessage = b2Context.getResourceString("page.receipt.success");
    cancelUrl = b2Context.setReceiptOptions(cancelUrl, receiptMessage, null);
    response.sendRedirect(cancelUrl);
    Utils.log(Verbosity.INFORMATION, "Exiting system/config.jsp");
    return;
  }

  List<PortalRole> iRoles = Utils.getInstitutionRoles(null);
  String selectedIRoles = "," + b2Context.getSetting(Constants.IROLES_PARAMETER, "") + ",";
  int testUsers = Integer.parseInt(b2Context.getSetting(Constants.TEST_USERS_PARAMETER, "0"));

  pageContext.setAttribute("bundle", b2Context.getResourceStrings());
  pageContext.setAttribute("cancelUrl", cancelUrl);
  pageContext.setAttribute("descriptionname", Constants.DESCRIPTION_PARAMETER + "_");
  pageContext.setAttribute("descriptiontext", b2Context.getSetting(Constants.DESCRIPTION_PARAMETER));
  pageContext.setAttribute("iroles", b2Context.getSetting(Constants.IROLES_PARAMETER));
  pageContext.setAttribute("gradebook", b2Context.getSetting(Constants.GRADEBOOK_PARAMETER, "false"));
  pageContext.setAttribute("forcecourse", b2Context.getSetting(Constants.FORCE_COURSE_PARAMETER, "false"));
  pageContext.setAttribute("forcecoursepersession", b2Context.getSetting(Constants.FORCE_COURSE_PER_SESSION_PARAMETER, "false"));
  pageContext.setAttribute("tests", b2Context.getSetting(Constants.TESTS_PARAMETER, "false"));
  pageContext.setAttribute("testbegin", b2Context.getSetting(Constants.TEST_BEGIN_PARAMETER, "false"));
  pageContext.setAttribute("testend", b2Context.getSetting(Constants.TEST_END_PARAMETER, "false"));

  Utils.log(Verbosity.INFORMATION, "Exiting system/config.jsp");
%>
  <bbNG:pageHeader instructions="${bundle['page.system.instructions']}">
    <bbNG:breadcrumbBar environment="SYS_ADMIN_PANEL" navItem="admin_plugin_manage">
      <bbNG:breadcrumb>${bundle['plugin.name']}</bbNG:breadcrumb>
    </bbNG:breadcrumbBar>
    <bbNG:pageTitleBar iconUrl="../images/bsi.gif" showTitleBar="true" title="${bundle['page.system.title']}"/>
  </bbNG:pageHeader>
  <bbNG:form action="" id="configForm" name="configForm" method="post" onsubmit="return validateForm();">
  <bbNG:dataCollection markUnsavedChanges="true" showSubmitButtons="true">
    <bbNG:step hideNumber="false" id="stepOne" title="${bundle['page.system.step1.title']}" instructions="${bundle['page.system.step1.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step1.url.label']}">
        <bbNG:textElement name="<%=Constants.URL_PARAMETER%>" value="<%=b2Context.getSetting(Constants.URL_PARAMETER)%>" helpText="${bundle['page.system.step1.url.instructions']}" placeHolder="${bundle['page.system.step1.url.placeholder']}" size="80" minLength="1" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step1.sharedcode.label']}">
        <bbNG:textElement name="<%=Constants.SHARED_CODE_PARAMETER%>" value="<%=b2Context.getSetting(Constants.SHARED_CODE_PARAMETER)%>" helpText="${bundle['page.system.step1.sharedcode.instructions']}" placeHolder="${bundle['page.system.step1.sharedcode.placeholder']}" size="40" minLength="1" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step1.systemid.label']}">
        <bbNG:textElement name="<%=Constants.SYSTEM_ID_PARAMETER%>" value="<%=b2Context.getSetting(Constants.SYSTEM_ID_PARAMETER)%>" helpText="${bundle['page.system.step1.systemid.instructions']}" placeHolder="${bundle['page.system.step1.systemid.placeholder']}" size="40" minLength="1" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step1.customerid.label']}">
        <bbNG:textElement name="<%=Constants.CUSTOMER_ID_PARAMETER%>" value="<%=b2Context.getSetting(Constants.CUSTOMER_ID_PARAMETER)%>" helpText="${bundle['page.system.step1.customerid.instructions']}" placeHolder="${bundle['page.system.step1.customerid.placeholder']}" size="40" minLength="1" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step1.locale.label']}">
        <bbNG:textElement name="<%=Constants.DEFAULT_LOCALE_PARAMETER%>" value="<%=b2Context.getSetting(Constants.DEFAULT_LOCALE_PARAMETER)%>" helpText="${bundle['page.system.step1.locale.instructions']}" placeHolder="${bundle['page.system.step1.locale.placeholder']}" size="40" minLength="1" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="false" label="${bundle['page.system.step1.biosight.label']}">
        <bbNG:textElement name="<%=Constants.BIOSIGHT_DOMAIN_PARAMETER%>" value="<%=b2Context.getSetting(Constants.BIOSIGHT_DOMAIN_PARAMETER)%>" helpText="${bundle['page.system.step1.biosight.instructions']}" placeHolder="${Constants.BIOSIGHT_DOMAIN_DEFAULT} ${bundle['page.system.step1.biosight.placeholder']}" size="60" minLength="0" />
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:step hideNumber="false" id="stepTwo" title="${bundle['page.system.step2.title']}" instructions="${bundle['page.system.step2.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step2.passphrase.label']}">
        <bbNG:textElement name="<%=Constants.PASS_PHRASE_PARAMETER%>" value="<%=b2Context.getSetting(Constants.PASS_PHRASE_PARAMETER)%>" helpText="${bundle['page.system.step2.passphrase.instructions']}" placeHolder="${bundle['page.system.step2.passphrase.placeholder']}" size="50" minLength="8" maxLength="36" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step2.salt.label']}">
        <bbNG:textElement name="<%=Constants.SALT_PARAMETER%>" value="<%=b2Context.getSetting(Constants.SALT_PARAMETER)%>" helpText="${bundle['page.system.step2.salt.instructions']}" placeHolder="${bundle['page.system.step2.salt.placeholder']}" size="50" minLength="8" maxLength="36" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step2.vector.label']}">
        <bbNG:textElement name="<%=Constants.VECTOR_PARAMETER%>" value="<%=b2Context.getSetting(Constants.VECTOR_PARAMETER)%>" helpText="${bundle['page.system.step2.vector.instructions']}" placeHolder="${bundle['page.system.step2.vector.placeholder']}" size="25" minLength="16" maxLength="16" />
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:step hideNumber="false" id="stepThree" title="${bundle['page.system.step3.title']}" instructions="${bundle['page.system.step3.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step3.title.label']}">
        <bbNG:textElement name="<%=Constants.TITLE_PARAMETER%>" value="<%=b2Context.getSetting(Constants.TITLE_PARAMETER)%>" helpText="${bundle['page.system.step3.title.instructions']}" size="50" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step3.description.label']}">
        <bbNG:textbox name="${descriptionname}" format="<%=b2Context.getSetting(Constants.DESCRIPTION_TYPE_PARAMETER)%>" text="${descriptiontext}" helpText="${bundle['page.content.step3.description.description']}" />
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:step hideNumber="false" id="stepFour" title="${bundle['page.system.step4.title']}" instructions="${bundle['page.system.step4.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.forcecourse.label']}">
        <bbNG:checkboxElement isSelected="${forcecourse}" name="<%=Constants.FORCE_COURSE_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.forcecourse.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.forcecoursepersession.label']}">
        <bbNG:checkboxElement isSelected="${forcecoursepersession}" name="<%=Constants.FORCE_COURSE_PER_SESSION_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.forcecoursepersession.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testlaunch.label']}">
        <bbNG:checkboxElement isSelected="${tests}" name="<%=Constants.TESTS_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testlaunch.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testbegin.label']}">
        <bbNG:checkboxElement isSelected="${testbegin}" name="<%=Constants.TEST_BEGIN_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testbegin.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testusers.label']}">
        <bbNG:selectElement isRequired="true" name="<%=Constants.TEST_USERS_PARAMETER%>" helpText="${bundle['page.system.step4.testusers.instructions']}">
<%
    String str;
    String strLabel;
    boolean selected;
    for (int i = 0; i <= 100; i++) {
      str = String.valueOf(i);
      strLabel = str + '%';
      if (i == 0) {
        str = "";
      }
      selected = (i == testUsers);
%>
          <bbNG:selectOptionElement isSelected="<%=selected%>" value="<%=str%>" optionLabel="<%=strLabel%>" />
<%
    }
%>
        </bbNG:selectElement>
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step4.testend.label']}">
        <bbNG:checkboxElement isSelected="${testend}" name="<%=Constants.TEST_END_PARAMETER%>" value="true" helpText="${bundle['page.system.step4.testend.instructions']}" />
      </bbNG:dataElement>
      <bbNG:dataElement isRequired="false" label="${bundle['page.system.step4.iroles.label']}">
        <bbNG:elementInstructions text="${bundle['page.system.step4.iroles.instructions']}" />
        <bbNG:settingsPageList collection="<%=iRoles%>" objectVar="iRole" className="PortalRole" reorderable="false">
<%
        pageContext.setAttribute("selected", selectedIRoles.indexOf("," + iRole.getRoleID() + ",") >= 0);
%>
          <bbNG:listElement isRowHeader="true" label="${bundle['page.system.step4.iroles.title']}" name="name">
            ${iRole.roleName}
          </bbNG:listElement>
          <bbNG:listElement isRowHeader="false" name="F" label="${bundle['page.system.step4.iroles.selected']}">
            <bbNG:checkboxElement isSelected="${selected}" name="<%=Constants.IROLES_PARAMETER%>" value="${iRole.roleID}" />
          </bbNG:listElement>
        </bbNG:settingsPageList>
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:step hideNumber="false" id="stepFive" title="${bundle['page.system.step5.title']}" instructions="${bundle['page.system.step5.instructions']}">
      <bbNG:dataElement isRequired="true" label="${bundle['page.system.step5.gradebook.label']}">
        <bbNG:checkboxElement isSelected="${gradebook}" name="<%=Constants.GRADEBOOK_PARAMETER%>" value="true" helpText="${bundle['page.system.step5.gradebook.instructions']}" />
      </bbNG:dataElement>
    </bbNG:step>
    <bbNG:stepSubmit hideNumber="false" showCancelButton="true" cancelUrl="${cancelUrl}" />
  </bbNG:dataCollection>
  </bbNG:form>
</bbNG:genericPage>
